Draft Upgrade: Difference between revisions

From FreeCAD Documentation
m (Changed section to 'Usage')
(Button text.)
 
(39 intermediate revisions by 4 users not shown)
Line 1: Line 1:
<languages/>
<languages/>
<translate>
<translate>

<!--T:20-->
<!--T:20-->
{{Docnav
{{Docnav|[[Draft_Split|Split]]|[[Draft_Downgrade|Downgrade]]|[[Draft_Module|Draft]]|IconL=Draft_Split.svg|IconC=Workbench_Draft.svg|IconR=Draft_Downgrade.svg}}
|[[Draft_Split|Split]]
|[[Draft_Downgrade|Downgrade]]
|[[Draft_Workbench|Draft]]
|IconL=Draft_Split.svg
|IconR=Draft_Downgrade.svg
|IconC=Workbench_Draft.svg
}}


<!--T:1-->
<!--T:1-->
{{GuiCommand
{{GuiCommand
|Name=Draft Upgrade
|Name=Draft Upgrade
|MenuLocation=Draft → Upgrade
|MenuLocation=Modification → Upgrade
|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]
|Workbenches=[[Draft_Workbench|Draft]], [[Arch_Workbench|Arch]]
|Shortcut=U P
|Shortcut={{KEY|U}} {{KEY|P}}
|SeeAlso=[[Draft Downgrade|Draft Downgrade]], [[Part Union]]
|SeeAlso=[[Draft_Downgrade|Draft Downgrade]]
}}
}}


Line 16: Line 24:


<!--T:3-->
<!--T:3-->
The [[Image:Draft_Upgrade.svg|24px]] '''Draft Upgrade''' command upgrades selected objects. The result depends on the number of selected objects and their type. The command can for example fuse elements and create faces. It is worth trying to upgrade a selection several times to see if a better result can be obtained. See the example in the image. Note that not all objects can be upgraded. This command is the counterpart of the [[Draft_Downgrade|Draft Downgrade]] command.
The Upgrade tool upgrades the selected objects in different ways.

<!--T:13-->
The Upgrade tool performs things such as creating faces and fusing different elements. This tool works with 2D Draft elements. To fuse 3D solids use [[Part Union]] and related Boolean operations of the [[Part Workbench]], and [[PartDesign Boolean]] of the [[PartDesign Workbench]].

<!--T:14-->
The counterpart to this tool is the [[Draft Downgrade]] operation.


</translate>
</translate>
Line 28: Line 30:
<translate>
<translate>
<!--T:15-->
<!--T:15-->
{{Caption|Open wire upgraded to a closed wire, then to a face; a closed square upgraded to a face, and then fused with the previous face}}
{{Caption|An open non-editable wire is upgraded to a closed wire, and then to a face. A closed non-editable square wire is also upgraded to a face. The two faces are then upgraded to create a compound, which is finally upgraded to a single editable Draft Wire.}}


==Usage== <!--T:4-->
==Usage== <!--T:4-->


<!--T:5-->
<!--T:5-->
# Select one or more objects that you wish to upgrade.
# Optionally select one or more objects.
# There are several ways to invoke the command:
# Press the {{Button|[[Image:Draft Upgrade.svg|16px]] [[Draft Upgrade]]}} button or press {{KEY|U}} then {{KEY|P}} keys. If no object is selected, you will be invited to select one.
#* Press the {{Button|[[Image:Draft_Upgrade.svg|16px]] [[Draft_Upgrade|Upgrade]]}} button.
#* Select the {{MenuCommand|Modification → [[Image:Draft_Upgrade.svg|16px]] Upgrade}} option from the menu.
#* Use the keyboard shortcut: {{KEY|U}} then {{KEY|P}}.
# If you have not yet selected an object: select an object in the [[3D_view|3D view]].


<!--T:16-->
==Notes== <!--T:24-->
The selected objects are modified or upgraded according to the following conditions, in order:
# If there are more than one face in the selection, the faces are merged (union).
# If there is only one face in the selection, nothing is done.
# If there is only one open wire in the selection, it gets closed, making a face.
# If there are only edges in the selection, all edges are joined into a wire, and the wire is closed if possible.
# If none of the above is possible, a compound object is created.


<!--T:17-->
<!--T:25-->
* [[Draft_Line|Draft Lines]] and [[Draft_Wire|Draft Wires]] can be joined with this command, but also with the [[Draft_Join|Draft Join]] command or the [[Draft_Wire|Draft Wire]] command.
It is worth trying to upgrade a selection several times to see if a better shape is obtained. For example:
# Upgrading two [[Draft Line]]s connected at one end will result in a non-editable wire.
# Upgrading this element again will add a third line and close the non-editable wire.
# Upgrading this element again will add a face to the closed, non-editable wire.
# Upgrading this element again will turn it into a [[Draft Wire]], which can be fully edited, and all its properties modified.


<!--T:18-->
==Scripting== <!--T:23-->
The resulting wire can be better manipulated than the original lines. The fusion of single lines can also be done directly with the [[Draft Wire]] tool. Some fusion operations can also be done with the [[Part Union|Part Union]] tool.


==Options== <!--T:6-->
<!--T:8-->
See also: [https://freecad.github.io/SourceDoc/ Autogenerated API documentation] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].

<!--T:7-->
There are no options for this tool. Either it works with the selected objects or not.

==Scripting== <!--T:8-->
{{Emphasis|See also:}} [[Draft API]] and [[FreeCAD Scripting Basics]].


<!--T:9-->
<!--T:9-->
To upgrade objects use the {{incode|upgrade}} method of the Draft module.
The Upgrade tool can be used in [[macros]] and from the [[Python]] console by using the following function:


</translate>
</translate>
{{Code|code=
{{Code|code=
upgrade_list = upgrade(objects, delete=False, force=None)
upgrade_list = upgrade(objects, delete=False, force=None)
addList, deleteList = upgrade(objects, delete=False, force=None)
}}
}}
<translate>
<translate>


<!--T:10-->
<!--T:10-->
* Upgrades the given {{incode|objects}}, which can be a single object or a list of objects.
* {{incode|objects}} contains the objects to be upgraded. It is either a single object or a list of objects.
* If {{incode|delete}} is {{incode|True}}, old objects are deleted.
* If {{incode|delete}} is {{incode|True}} the source objects are deleted.
* If {{incode|force}} is given, it is the internal function to call to force a certain way of upgrading. It can be: {{incode|"makeCompound"}}, {{incode|"closeGroupWires"}}, {{incode|"makeSolid"}}, {{incode|"closeWire"}}, {{incode|"turnToParts"}}, {{incode|"makeFusion"}}, {{incode|"makeShell"}}, {{incode|"makeFaces"}}, {{incode|"draftify"}}, {{incode|"joinFaces"}}, {{incode|"makeSketchFace"}}, {{incode|"makeWires"}}, or {{incode|"turnToLine"}}.
* {{incode|force}} forces a certain way of upgrading by calling a specific internal function. It can be: {{incode|"makeCompound"}}, {{incode|"closeGroupWires"}}, {{incode|"makeSolid"}}, {{incode|"closeWire"}}, {{incode|"turnToParts"}}, {{incode|"makeFusion"}}, {{incode|"makeShell"}}, {{incode|"makeFaces"}}, {{incode|"draftify"}}, {{incode|"joinFaces"}}, {{incode|"makeSketchFace"}}, {{incode|"makeWires"}} or {{incode|"turnToLine"}}.
* {{incode|upgrade_list}} is returned, which is a list containing two lists: a list of new objects ({{incode|addList}}) and a list of objects to be deleted ({{incode|deleteList}}).
* {{incode|upgrade_list}} is returned. It is a list containing two lists: a list of new objects and a list of objects to be deleted. If {{incode|delete}} is {{incode|True}} the second list is empty.


<!--T:12-->
<!--T:12-->
Line 83: Line 72:
</translate>
</translate>
{{Code|code=
{{Code|code=
import FreeCAD, Draft
import FreeCAD as App
import Draft


doc = App.newDocument()
Circle = Draft.makeCircle(1000)
Rectangle = Draft.makeRectangle(2000, 800)


circle = Draft.make_circle(1000)
addList1, deleteList1 = Draft.upgrade([Circle, Rectangle], delete=False)
rectangle = Draft.make_rectangle(2000, 800)
fused = addList1[0]
doc.recompute()


add_list1, delete_list1 = Draft.upgrade([circle, rectangle], delete=False)
Line1 = Draft.makeLine(FreeCAD.Vector(2000, 0, 0), FreeCAD.Vector(2500, 1500, 0))
Line2 = Draft.makeLine(FreeCAD.Vector(2500, 1500, 0), FreeCAD.Vector(3000, -1000, 0))
addList2, deleteList2 = Draft.upgrade([Line1, Line2], delete=False)


line1 = Draft.make_line(App.Vector(2000, 0, 0), App.Vector(2500, 1500, 0))
simple_wire = addList2[0]
line2 = Draft.make_line(App.Vector(2500, 1500, 0), App.Vector(3000, -1000, 0))
addList3, deleteList3 = Draft.upgrade(simple_wire, delete=False)
doc.recompute()


add_list2, delete_list2 = Draft.upgrade([line1, line2], delete=False)
closed_wire = addList3[0]
addList4, deleteList4 = Draft.upgrade(closed_wire, delete=False)


face = addList4[0]
simple_wire = add_list2[0]
addList5, deleteList5 = Draft.upgrade(face, delete=False)
add_list3, delete_list3 = Draft.upgrade(simple_wire, delete=False)

closed_wire = add_list3[0]
add_list4, delete_list4 = Draft.upgrade(closed_wire, delete=False)

face = add_list4[0]
add_list5, delete_list5 = Draft.upgrade(face, delete=False)

doc.recompute()
}}
}}
<translate>
<translate>


<!--T:19-->
{{Docnav|[[Draft_Split|Split]]|[[Draft_Downgrade|Downgrade]]|[[Draft_Module|Draft]]|IconL=Draft_Split.svg|IconC=Workbench_Draft.svg|IconR=Draft_Downgrade.svg}}


<!--T:21-->
<!--T:19-->
{{Docnav
{{Draft Tools navi}}
|[[Draft_Split|Split]]
|[[Draft_Downgrade|Downgrade]]
|[[Draft_Workbench|Draft]]
|IconL=Draft_Split.svg
|IconR=Draft_Downgrade.svg
|IconC=Workbench_Draft.svg
}}


<!--T:22-->
{{Userdocnavi}}
</translate>
</translate>
{{Draft Tools navi{{#translation:}}}}
{{clear}}
{{Userdocnavi{{#translation:}}}}

Latest revision as of 17:11, 3 December 2023

Draft Upgrade

Menu location
Modification → Upgrade
Workbenches
Draft, Arch
Default shortcut
U P
Introduced in version
-
See also
Draft Downgrade

Description

The Draft Upgrade command upgrades selected objects. The result depends on the number of selected objects and their type. The command can for example fuse elements and create faces. It is worth trying to upgrade a selection several times to see if a better result can be obtained. See the example in the image. Note that not all objects can be upgraded. This command is the counterpart of the Draft Downgrade command.

An open non-editable wire is upgraded to a closed wire, and then to a face. A closed non-editable square wire is also upgraded to a face. The two faces are then upgraded to create a compound, which is finally upgraded to a single editable Draft Wire.

Usage

  1. Optionally select one or more objects.
  2. There are several ways to invoke the command:
    • Press the Upgrade button.
    • Select the Modification → Upgrade option from the menu.
    • Use the keyboard shortcut: U then P.
  3. If you have not yet selected an object: select an object in the 3D view.

Notes

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To upgrade objects use the upgrade method of the Draft module.

upgrade_list = upgrade(objects, delete=False, force=None)
  • objects contains the objects to be upgraded. It is either a single object or a list of objects.
  • If delete is True the source objects are deleted.
  • force forces a certain way of upgrading by calling a specific internal function. It can be: "makeCompound", "closeGroupWires", "makeSolid", "closeWire", "turnToParts", "makeFusion", "makeShell", "makeFaces", "draftify", "joinFaces", "makeSketchFace", "makeWires" or "turnToLine".
  • upgrade_list is returned. It is a list containing two lists: a list of new objects and a list of objects to be deleted. If delete is True the second list is empty.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

circle = Draft.make_circle(1000)
rectangle = Draft.make_rectangle(2000, 800)
doc.recompute()

add_list1, delete_list1 = Draft.upgrade([circle, rectangle], delete=False)

line1 = Draft.make_line(App.Vector(2000, 0, 0), App.Vector(2500, 1500, 0))
line2 = Draft.make_line(App.Vector(2500, 1500, 0), App.Vector(3000, -1000, 0))
doc.recompute()

add_list2, delete_list2 = Draft.upgrade([line1, line2], delete=False)

simple_wire = add_list2[0]
add_list3, delete_list3 = Draft.upgrade(simple_wire, delete=False)

closed_wire = add_list3[0]
add_list4, delete_list4 = Draft.upgrade(closed_wire, delete=False)

face = add_list4[0]
add_list5, delete_list5 = Draft.upgrade(face, delete=False)

doc.recompute()